<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html lang="en">
<head>
<title>Source code</title>
<link rel="stylesheet" type="text/css" href="../../../../../stylesheet.css" title="Style">
</head>
<body>
<div class="sourceContainer">
<pre><span class="sourceLineNo">001</span>/*<a name="line.1"></a>
<span class="sourceLineNo">002</span> * Licensed to the Apache Software Foundation (ASF) under one or more<a name="line.2"></a>
<span class="sourceLineNo">003</span> * contributor license agreements.  See the NOTICE file distributed with<a name="line.3"></a>
<span class="sourceLineNo">004</span> * this work for additional information regarding copyright ownership.<a name="line.4"></a>
<span class="sourceLineNo">005</span> * The ASF licenses this file to You under the Apache License, Version 2.0<a name="line.5"></a>
<span class="sourceLineNo">006</span> * (the "License"); you may not use this file except in compliance with<a name="line.6"></a>
<span class="sourceLineNo">007</span> * the License.  You may obtain a copy of the License at<a name="line.7"></a>
<span class="sourceLineNo">008</span> *<a name="line.8"></a>
<span class="sourceLineNo">009</span> *      http://www.apache.org/licenses/LICENSE-2.0<a name="line.9"></a>
<span class="sourceLineNo">010</span> *<a name="line.10"></a>
<span class="sourceLineNo">011</span> * Unless required by applicable law or agreed to in writing, software<a name="line.11"></a>
<span class="sourceLineNo">012</span> * distributed under the License is distributed on an "AS IS" BASIS,<a name="line.12"></a>
<span class="sourceLineNo">013</span> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.<a name="line.13"></a>
<span class="sourceLineNo">014</span> * See the License for the specific language governing permissions and<a name="line.14"></a>
<span class="sourceLineNo">015</span> * limitations under the License.<a name="line.15"></a>
<span class="sourceLineNo">016</span> */<a name="line.16"></a>
<span class="sourceLineNo">017</span>package org.apache.commons.dbcp2;<a name="line.17"></a>
<span class="sourceLineNo">018</span><a name="line.18"></a>
<span class="sourceLineNo">019</span>import java.io.InputStream;<a name="line.19"></a>
<span class="sourceLineNo">020</span>import java.io.Reader;<a name="line.20"></a>
<span class="sourceLineNo">021</span>import java.math.BigDecimal;<a name="line.21"></a>
<span class="sourceLineNo">022</span>import java.net.URL;<a name="line.22"></a>
<span class="sourceLineNo">023</span>import java.sql.Array;<a name="line.23"></a>
<span class="sourceLineNo">024</span>import java.sql.Blob;<a name="line.24"></a>
<span class="sourceLineNo">025</span>import java.sql.Clob;<a name="line.25"></a>
<span class="sourceLineNo">026</span>import java.sql.Connection;<a name="line.26"></a>
<span class="sourceLineNo">027</span>import java.sql.DatabaseMetaData;<a name="line.27"></a>
<span class="sourceLineNo">028</span>import java.sql.Date;<a name="line.28"></a>
<span class="sourceLineNo">029</span>import java.sql.Ref;<a name="line.29"></a>
<span class="sourceLineNo">030</span>import java.sql.ResultSet;<a name="line.30"></a>
<span class="sourceLineNo">031</span>import java.sql.RowId;<a name="line.31"></a>
<span class="sourceLineNo">032</span>import java.sql.SQLException;<a name="line.32"></a>
<span class="sourceLineNo">033</span>import java.sql.SQLFeatureNotSupportedException;<a name="line.33"></a>
<span class="sourceLineNo">034</span>import java.sql.SQLXML;<a name="line.34"></a>
<span class="sourceLineNo">035</span>import java.sql.Statement;<a name="line.35"></a>
<span class="sourceLineNo">036</span>import java.sql.Time;<a name="line.36"></a>
<span class="sourceLineNo">037</span>import java.sql.Timestamp;<a name="line.37"></a>
<span class="sourceLineNo">038</span>import java.util.concurrent.Executor;<a name="line.38"></a>
<span class="sourceLineNo">039</span>import java.util.logging.Logger;<a name="line.39"></a>
<span class="sourceLineNo">040</span><a name="line.40"></a>
<span class="sourceLineNo">041</span>import javax.sql.CommonDataSource;<a name="line.41"></a>
<span class="sourceLineNo">042</span><a name="line.42"></a>
<span class="sourceLineNo">043</span>/**<a name="line.43"></a>
<span class="sourceLineNo">044</span> * Defines bridge methods to JDBC 4.1 (Java 7) methods to allow call sites to operate safely (without<a name="line.44"></a>
<span class="sourceLineNo">045</span> * {@link AbstractMethodError}) when using a JDBC driver written for JDBC 4.0 (Java 6).<a name="line.45"></a>
<span class="sourceLineNo">046</span> *<a name="line.46"></a>
<span class="sourceLineNo">047</span> * @since 2.6.0<a name="line.47"></a>
<span class="sourceLineNo">048</span> */<a name="line.48"></a>
<span class="sourceLineNo">049</span>public class Jdbc41Bridge {<a name="line.49"></a>
<span class="sourceLineNo">050</span><a name="line.50"></a>
<span class="sourceLineNo">051</span>    /**<a name="line.51"></a>
<span class="sourceLineNo">052</span>     * Delegates to {@link Connection#abort(Executor)} without throwing an {@link AbstractMethodError}.<a name="line.52"></a>
<span class="sourceLineNo">053</span>     * &lt;p&gt;<a name="line.53"></a>
<span class="sourceLineNo">054</span>     * If the JDBC driver does not implement {@link Connection#abort(Executor)}, then call {@link Connection#close()}.<a name="line.54"></a>
<span class="sourceLineNo">055</span>     * &lt;/p&gt;<a name="line.55"></a>
<span class="sourceLineNo">056</span>     *<a name="line.56"></a>
<span class="sourceLineNo">057</span>     * @param connection<a name="line.57"></a>
<span class="sourceLineNo">058</span>     *            the receiver<a name="line.58"></a>
<span class="sourceLineNo">059</span>     * @param executor<a name="line.59"></a>
<span class="sourceLineNo">060</span>     *            See {@link Connection#abort(Executor)}.<a name="line.60"></a>
<span class="sourceLineNo">061</span>     * @throws SQLException<a name="line.61"></a>
<span class="sourceLineNo">062</span>     *             See {@link Connection#abort(Executor)}.<a name="line.62"></a>
<span class="sourceLineNo">063</span>     * @see Connection#abort(Executor)<a name="line.63"></a>
<span class="sourceLineNo">064</span>     */<a name="line.64"></a>
<span class="sourceLineNo">065</span>    public static void abort(final Connection connection, final Executor executor) throws SQLException {<a name="line.65"></a>
<span class="sourceLineNo">066</span>        try {<a name="line.66"></a>
<span class="sourceLineNo">067</span>            connection.abort(executor);<a name="line.67"></a>
<span class="sourceLineNo">068</span>        } catch (final AbstractMethodError e) {<a name="line.68"></a>
<span class="sourceLineNo">069</span>            connection.close();<a name="line.69"></a>
<span class="sourceLineNo">070</span>        }<a name="line.70"></a>
<span class="sourceLineNo">071</span>    }<a name="line.71"></a>
<span class="sourceLineNo">072</span><a name="line.72"></a>
<span class="sourceLineNo">073</span>    /**<a name="line.73"></a>
<span class="sourceLineNo">074</span>     * Delegates to {@link DatabaseMetaData#generatedKeyAlwaysReturned()} without throwing a<a name="line.74"></a>
<span class="sourceLineNo">075</span>     * {@link AbstractMethodError}.<a name="line.75"></a>
<span class="sourceLineNo">076</span>     * &lt;p&gt;<a name="line.76"></a>
<span class="sourceLineNo">077</span>     * If the JDBC driver does not implement {@link DatabaseMetaData#generatedKeyAlwaysReturned()}, then return false.<a name="line.77"></a>
<span class="sourceLineNo">078</span>     * &lt;/p&gt;<a name="line.78"></a>
<span class="sourceLineNo">079</span>     *<a name="line.79"></a>
<span class="sourceLineNo">080</span>     * @param databaseMetaData<a name="line.80"></a>
<span class="sourceLineNo">081</span>     *            See {@link DatabaseMetaData#generatedKeyAlwaysReturned()}<a name="line.81"></a>
<span class="sourceLineNo">082</span>     * @return See {@link DatabaseMetaData#generatedKeyAlwaysReturned()}<a name="line.82"></a>
<span class="sourceLineNo">083</span>     * @throws SQLException<a name="line.83"></a>
<span class="sourceLineNo">084</span>     *             See {@link DatabaseMetaData#generatedKeyAlwaysReturned()}<a name="line.84"></a>
<span class="sourceLineNo">085</span>     * @see DatabaseMetaData#generatedKeyAlwaysReturned()<a name="line.85"></a>
<span class="sourceLineNo">086</span>     */<a name="line.86"></a>
<span class="sourceLineNo">087</span>    public static boolean generatedKeyAlwaysReturned(final DatabaseMetaData databaseMetaData) throws SQLException {<a name="line.87"></a>
<span class="sourceLineNo">088</span>        try {<a name="line.88"></a>
<span class="sourceLineNo">089</span>            return databaseMetaData.generatedKeyAlwaysReturned();<a name="line.89"></a>
<span class="sourceLineNo">090</span>        } catch (final AbstractMethodError e) {<a name="line.90"></a>
<span class="sourceLineNo">091</span>            // do nothing<a name="line.91"></a>
<span class="sourceLineNo">092</span>            return false;<a name="line.92"></a>
<span class="sourceLineNo">093</span>        }<a name="line.93"></a>
<span class="sourceLineNo">094</span>    }<a name="line.94"></a>
<span class="sourceLineNo">095</span><a name="line.95"></a>
<span class="sourceLineNo">096</span>    /**<a name="line.96"></a>
<span class="sourceLineNo">097</span>     * Delegates to {@link Connection#getNetworkTimeout()} without throwing an {@link AbstractMethodError}.<a name="line.97"></a>
<span class="sourceLineNo">098</span>     * &lt;p&gt;<a name="line.98"></a>
<span class="sourceLineNo">099</span>     * If the JDBC driver does not implement {@link Connection#getNetworkTimeout()}, then return 0.<a name="line.99"></a>
<span class="sourceLineNo">100</span>     * &lt;/p&gt;<a name="line.100"></a>
<span class="sourceLineNo">101</span>     *<a name="line.101"></a>
<span class="sourceLineNo">102</span>     * @param connection<a name="line.102"></a>
<span class="sourceLineNo">103</span>     *            the receiver<a name="line.103"></a>
<span class="sourceLineNo">104</span>     * @return See {@link Connection#getNetworkTimeout()}<a name="line.104"></a>
<span class="sourceLineNo">105</span>     * @throws SQLException<a name="line.105"></a>
<span class="sourceLineNo">106</span>     *             See {@link Connection#getNetworkTimeout()}<a name="line.106"></a>
<span class="sourceLineNo">107</span>     * @see Connection#getNetworkTimeout()<a name="line.107"></a>
<span class="sourceLineNo">108</span>     */<a name="line.108"></a>
<span class="sourceLineNo">109</span>    public static int getNetworkTimeout(final Connection connection) throws SQLException {<a name="line.109"></a>
<span class="sourceLineNo">110</span>        try {<a name="line.110"></a>
<span class="sourceLineNo">111</span>            return connection.getNetworkTimeout();<a name="line.111"></a>
<span class="sourceLineNo">112</span>        } catch (final AbstractMethodError e) {<a name="line.112"></a>
<span class="sourceLineNo">113</span>            return 0;<a name="line.113"></a>
<span class="sourceLineNo">114</span>        }<a name="line.114"></a>
<span class="sourceLineNo">115</span>    }<a name="line.115"></a>
<span class="sourceLineNo">116</span><a name="line.116"></a>
<span class="sourceLineNo">117</span>    /**<a name="line.117"></a>
<span class="sourceLineNo">118</span>     * Delegates to {@link ResultSet#getObject(int, Class)} without throwing an {@link AbstractMethodError}.<a name="line.118"></a>
<span class="sourceLineNo">119</span>     * &lt;p&gt;<a name="line.119"></a>
<span class="sourceLineNo">120</span>     * If the JDBC driver does not implement {@link ResultSet#getObject(int, Class)}, then return 0.<a name="line.120"></a>
<span class="sourceLineNo">121</span>     * &lt;/p&gt;<a name="line.121"></a>
<span class="sourceLineNo">122</span>     *<a name="line.122"></a>
<span class="sourceLineNo">123</span>     * @param &lt;T&gt;<a name="line.123"></a>
<span class="sourceLineNo">124</span>     *            See {@link ResultSet#getObject(int, Class)}<a name="line.124"></a>
<span class="sourceLineNo">125</span>     * @param resultSet<a name="line.125"></a>
<span class="sourceLineNo">126</span>     *            See {@link ResultSet#getObject(int, Class)}<a name="line.126"></a>
<span class="sourceLineNo">127</span>     * @param columnIndex<a name="line.127"></a>
<span class="sourceLineNo">128</span>     *            See {@link ResultSet#getObject(int, Class)}<a name="line.128"></a>
<span class="sourceLineNo">129</span>     * @param type<a name="line.129"></a>
<span class="sourceLineNo">130</span>     *            See {@link ResultSet#getObject(int, Class)}<a name="line.130"></a>
<span class="sourceLineNo">131</span>     * @return See {@link ResultSet#getObject(int, Class)}<a name="line.131"></a>
<span class="sourceLineNo">132</span>     * @throws SQLException<a name="line.132"></a>
<span class="sourceLineNo">133</span>     *             See {@link ResultSet#getObject(int, Class)}<a name="line.133"></a>
<span class="sourceLineNo">134</span>     * @see ResultSet#getObject(int, Class)<a name="line.134"></a>
<span class="sourceLineNo">135</span>     */<a name="line.135"></a>
<span class="sourceLineNo">136</span>    @SuppressWarnings("unchecked")<a name="line.136"></a>
<span class="sourceLineNo">137</span>    public static &lt;T&gt; T getObject(final ResultSet resultSet, final int columnIndex, final Class&lt;T&gt; type)<a name="line.137"></a>
<span class="sourceLineNo">138</span>            throws SQLException {<a name="line.138"></a>
<span class="sourceLineNo">139</span>        try {<a name="line.139"></a>
<span class="sourceLineNo">140</span>            return resultSet.getObject(columnIndex, type);<a name="line.140"></a>
<span class="sourceLineNo">141</span>        } catch (final AbstractMethodError e) {<a name="line.141"></a>
<span class="sourceLineNo">142</span>            if (type == String.class) {<a name="line.142"></a>
<span class="sourceLineNo">143</span>                return (T) resultSet.getString(columnIndex);<a name="line.143"></a>
<span class="sourceLineNo">144</span>            }<a name="line.144"></a>
<span class="sourceLineNo">145</span>            // Numbers<a name="line.145"></a>
<span class="sourceLineNo">146</span>            if (type == Integer.class) {<a name="line.146"></a>
<span class="sourceLineNo">147</span>                return (T) Integer.valueOf(resultSet.getInt(columnIndex));<a name="line.147"></a>
<span class="sourceLineNo">148</span>            }<a name="line.148"></a>
<span class="sourceLineNo">149</span>            if (type == Long.class) {<a name="line.149"></a>
<span class="sourceLineNo">150</span>                return (T) Long.valueOf(resultSet.getLong(columnIndex));<a name="line.150"></a>
<span class="sourceLineNo">151</span>            }<a name="line.151"></a>
<span class="sourceLineNo">152</span>            if (type == Double.class) {<a name="line.152"></a>
<span class="sourceLineNo">153</span>                return (T) Double.valueOf(resultSet.getDouble(columnIndex));<a name="line.153"></a>
<span class="sourceLineNo">154</span>            }<a name="line.154"></a>
<span class="sourceLineNo">155</span>            if (type == Float.class) {<a name="line.155"></a>
<span class="sourceLineNo">156</span>                return (T) Float.valueOf(resultSet.getFloat(columnIndex));<a name="line.156"></a>
<span class="sourceLineNo">157</span>            }<a name="line.157"></a>
<span class="sourceLineNo">158</span>            if (type == Short.class) {<a name="line.158"></a>
<span class="sourceLineNo">159</span>                return (T) Short.valueOf(resultSet.getShort(columnIndex));<a name="line.159"></a>
<span class="sourceLineNo">160</span>            }<a name="line.160"></a>
<span class="sourceLineNo">161</span>            if (type == BigDecimal.class) {<a name="line.161"></a>
<span class="sourceLineNo">162</span>                return (T) resultSet.getBigDecimal(columnIndex);<a name="line.162"></a>
<span class="sourceLineNo">163</span>            }<a name="line.163"></a>
<span class="sourceLineNo">164</span>            if (type == Byte.class) {<a name="line.164"></a>
<span class="sourceLineNo">165</span>                return (T) Byte.valueOf(resultSet.getByte(columnIndex));<a name="line.165"></a>
<span class="sourceLineNo">166</span>            }<a name="line.166"></a>
<span class="sourceLineNo">167</span>            // Dates<a name="line.167"></a>
<span class="sourceLineNo">168</span>            if (type == Date.class) {<a name="line.168"></a>
<span class="sourceLineNo">169</span>                return (T) resultSet.getDate(columnIndex);<a name="line.169"></a>
<span class="sourceLineNo">170</span>            }<a name="line.170"></a>
<span class="sourceLineNo">171</span>            if (type == Time.class) {<a name="line.171"></a>
<span class="sourceLineNo">172</span>                return (T) resultSet.getTime(columnIndex);<a name="line.172"></a>
<span class="sourceLineNo">173</span>            }<a name="line.173"></a>
<span class="sourceLineNo">174</span>            if (type == Timestamp.class) {<a name="line.174"></a>
<span class="sourceLineNo">175</span>                return (T) resultSet.getTimestamp(columnIndex);<a name="line.175"></a>
<span class="sourceLineNo">176</span>            }<a name="line.176"></a>
<span class="sourceLineNo">177</span>            // Streams<a name="line.177"></a>
<span class="sourceLineNo">178</span>            if (type == InputStream.class) {<a name="line.178"></a>
<span class="sourceLineNo">179</span>                return (T) resultSet.getBinaryStream(columnIndex);<a name="line.179"></a>
<span class="sourceLineNo">180</span>            }<a name="line.180"></a>
<span class="sourceLineNo">181</span>            if (type == Reader.class) {<a name="line.181"></a>
<span class="sourceLineNo">182</span>                return (T) resultSet.getCharacterStream(columnIndex);<a name="line.182"></a>
<span class="sourceLineNo">183</span>            }<a name="line.183"></a>
<span class="sourceLineNo">184</span>            // Other<a name="line.184"></a>
<span class="sourceLineNo">185</span>            if (type == Object.class) {<a name="line.185"></a>
<span class="sourceLineNo">186</span>                return (T) resultSet.getObject(columnIndex);<a name="line.186"></a>
<span class="sourceLineNo">187</span>            }<a name="line.187"></a>
<span class="sourceLineNo">188</span>            if (type == Boolean.class) {<a name="line.188"></a>
<span class="sourceLineNo">189</span>                return (T) Boolean.valueOf(resultSet.getBoolean(columnIndex));<a name="line.189"></a>
<span class="sourceLineNo">190</span>            }<a name="line.190"></a>
<span class="sourceLineNo">191</span>            if (type == Array.class) {<a name="line.191"></a>
<span class="sourceLineNo">192</span>                return (T) resultSet.getArray(columnIndex);<a name="line.192"></a>
<span class="sourceLineNo">193</span>            }<a name="line.193"></a>
<span class="sourceLineNo">194</span>            if (type == Blob.class) {<a name="line.194"></a>
<span class="sourceLineNo">195</span>                return (T) resultSet.getBlob(columnIndex);<a name="line.195"></a>
<span class="sourceLineNo">196</span>            }<a name="line.196"></a>
<span class="sourceLineNo">197</span>            if (type == Clob.class) {<a name="line.197"></a>
<span class="sourceLineNo">198</span>                return (T) resultSet.getClob(columnIndex);<a name="line.198"></a>
<span class="sourceLineNo">199</span>            }<a name="line.199"></a>
<span class="sourceLineNo">200</span>            if (type == Ref.class) {<a name="line.200"></a>
<span class="sourceLineNo">201</span>                return (T) resultSet.getRef(columnIndex);<a name="line.201"></a>
<span class="sourceLineNo">202</span>            }<a name="line.202"></a>
<span class="sourceLineNo">203</span>            if (type == RowId.class) {<a name="line.203"></a>
<span class="sourceLineNo">204</span>                return (T) resultSet.getRowId(columnIndex);<a name="line.204"></a>
<span class="sourceLineNo">205</span>            }<a name="line.205"></a>
<span class="sourceLineNo">206</span>            if (type == SQLXML.class) {<a name="line.206"></a>
<span class="sourceLineNo">207</span>                return (T) resultSet.getSQLXML(columnIndex);<a name="line.207"></a>
<span class="sourceLineNo">208</span>            }<a name="line.208"></a>
<span class="sourceLineNo">209</span>            if (type == URL.class) {<a name="line.209"></a>
<span class="sourceLineNo">210</span>                return (T) resultSet.getURL(columnIndex);<a name="line.210"></a>
<span class="sourceLineNo">211</span>            }<a name="line.211"></a>
<span class="sourceLineNo">212</span>            throw new SQLFeatureNotSupportedException(<a name="line.212"></a>
<span class="sourceLineNo">213</span>                    String.format("resultSet=%s, columnIndex=%,d, type=%s", resultSet, columnIndex, type));<a name="line.213"></a>
<span class="sourceLineNo">214</span>        }<a name="line.214"></a>
<span class="sourceLineNo">215</span>    }<a name="line.215"></a>
<span class="sourceLineNo">216</span><a name="line.216"></a>
<span class="sourceLineNo">217</span>    /**<a name="line.217"></a>
<span class="sourceLineNo">218</span>     * Delegates to {@link ResultSet#getObject(String, Class)} without throwing an {@link AbstractMethodError}.<a name="line.218"></a>
<span class="sourceLineNo">219</span>     *<a name="line.219"></a>
<span class="sourceLineNo">220</span>     * @param &lt;T&gt;<a name="line.220"></a>
<span class="sourceLineNo">221</span>     *            See {@link ResultSet#getObject(String, Class)}<a name="line.221"></a>
<span class="sourceLineNo">222</span>     * @param resultSet<a name="line.222"></a>
<span class="sourceLineNo">223</span>     *            See {@link ResultSet#getObject(String, Class)}<a name="line.223"></a>
<span class="sourceLineNo">224</span>     * @param columnLabel<a name="line.224"></a>
<span class="sourceLineNo">225</span>     *            See {@link ResultSet#getObject(String, Class)}<a name="line.225"></a>
<span class="sourceLineNo">226</span>     * @param type<a name="line.226"></a>
<span class="sourceLineNo">227</span>     *            See {@link ResultSet#getObject(String, Class)}<a name="line.227"></a>
<span class="sourceLineNo">228</span>     * @return See {@link ResultSet#getObject(String, Class)}<a name="line.228"></a>
<span class="sourceLineNo">229</span>     * @throws SQLException<a name="line.229"></a>
<span class="sourceLineNo">230</span>     *             See {@link ResultSet#getObject(String, Class)}<a name="line.230"></a>
<span class="sourceLineNo">231</span>     * @see ResultSet#getObject(int, Class)<a name="line.231"></a>
<span class="sourceLineNo">232</span>     */<a name="line.232"></a>
<span class="sourceLineNo">233</span>    @SuppressWarnings("unchecked")<a name="line.233"></a>
<span class="sourceLineNo">234</span>    public static &lt;T&gt; T getObject(final ResultSet resultSet, final String columnLabel, final Class&lt;T&gt; type)<a name="line.234"></a>
<span class="sourceLineNo">235</span>            throws SQLException {<a name="line.235"></a>
<span class="sourceLineNo">236</span>        try {<a name="line.236"></a>
<span class="sourceLineNo">237</span>            return resultSet.getObject(columnLabel, type);<a name="line.237"></a>
<span class="sourceLineNo">238</span>        } catch (final AbstractMethodError e) {<a name="line.238"></a>
<span class="sourceLineNo">239</span>            // Numbers<a name="line.239"></a>
<span class="sourceLineNo">240</span>            if (type == Integer.class) {<a name="line.240"></a>
<span class="sourceLineNo">241</span>                return (T) Integer.valueOf(resultSet.getInt(columnLabel));<a name="line.241"></a>
<span class="sourceLineNo">242</span>            }<a name="line.242"></a>
<span class="sourceLineNo">243</span>            if (type == Long.class) {<a name="line.243"></a>
<span class="sourceLineNo">244</span>                return (T) Long.valueOf(resultSet.getLong(columnLabel));<a name="line.244"></a>
<span class="sourceLineNo">245</span>            }<a name="line.245"></a>
<span class="sourceLineNo">246</span>            if (type == Double.class) {<a name="line.246"></a>
<span class="sourceLineNo">247</span>                return (T) Double.valueOf(resultSet.getDouble(columnLabel));<a name="line.247"></a>
<span class="sourceLineNo">248</span>            }<a name="line.248"></a>
<span class="sourceLineNo">249</span>            if (type == Float.class) {<a name="line.249"></a>
<span class="sourceLineNo">250</span>                return (T) Float.valueOf(resultSet.getFloat(columnLabel));<a name="line.250"></a>
<span class="sourceLineNo">251</span>            }<a name="line.251"></a>
<span class="sourceLineNo">252</span>            if (type == Short.class) {<a name="line.252"></a>
<span class="sourceLineNo">253</span>                return (T) Short.valueOf(resultSet.getShort(columnLabel));<a name="line.253"></a>
<span class="sourceLineNo">254</span>            }<a name="line.254"></a>
<span class="sourceLineNo">255</span>            if (type == BigDecimal.class) {<a name="line.255"></a>
<span class="sourceLineNo">256</span>                return (T) resultSet.getBigDecimal(columnLabel);<a name="line.256"></a>
<span class="sourceLineNo">257</span>            }<a name="line.257"></a>
<span class="sourceLineNo">258</span>            if (type == Byte.class) {<a name="line.258"></a>
<span class="sourceLineNo">259</span>                return (T) Byte.valueOf(resultSet.getByte(columnLabel));<a name="line.259"></a>
<span class="sourceLineNo">260</span>            }<a name="line.260"></a>
<span class="sourceLineNo">261</span>            // Dates<a name="line.261"></a>
<span class="sourceLineNo">262</span>            if (type == Date.class) {<a name="line.262"></a>
<span class="sourceLineNo">263</span>                return (T) resultSet.getDate(columnLabel);<a name="line.263"></a>
<span class="sourceLineNo">264</span>            }<a name="line.264"></a>
<span class="sourceLineNo">265</span>            if (type == Time.class) {<a name="line.265"></a>
<span class="sourceLineNo">266</span>                return (T) resultSet.getTime(columnLabel);<a name="line.266"></a>
<span class="sourceLineNo">267</span>            }<a name="line.267"></a>
<span class="sourceLineNo">268</span>            if (type == Timestamp.class) {<a name="line.268"></a>
<span class="sourceLineNo">269</span>                return (T) resultSet.getTimestamp(columnLabel);<a name="line.269"></a>
<span class="sourceLineNo">270</span>            }<a name="line.270"></a>
<span class="sourceLineNo">271</span>            // Streams<a name="line.271"></a>
<span class="sourceLineNo">272</span>            if (type == InputStream.class) {<a name="line.272"></a>
<span class="sourceLineNo">273</span>                return (T) resultSet.getBinaryStream(columnLabel);<a name="line.273"></a>
<span class="sourceLineNo">274</span>            }<a name="line.274"></a>
<span class="sourceLineNo">275</span>            if (type == Reader.class) {<a name="line.275"></a>
<span class="sourceLineNo">276</span>                return (T) resultSet.getCharacterStream(columnLabel);<a name="line.276"></a>
<span class="sourceLineNo">277</span>            }<a name="line.277"></a>
<span class="sourceLineNo">278</span>            // Other<a name="line.278"></a>
<span class="sourceLineNo">279</span>            if (type == Object.class) {<a name="line.279"></a>
<span class="sourceLineNo">280</span>                return (T) resultSet.getObject(columnLabel);<a name="line.280"></a>
<span class="sourceLineNo">281</span>            }<a name="line.281"></a>
<span class="sourceLineNo">282</span>            if (type == Boolean.class) {<a name="line.282"></a>
<span class="sourceLineNo">283</span>                return (T) Boolean.valueOf(resultSet.getBoolean(columnLabel));<a name="line.283"></a>
<span class="sourceLineNo">284</span>            }<a name="line.284"></a>
<span class="sourceLineNo">285</span>            if (type == Array.class) {<a name="line.285"></a>
<span class="sourceLineNo">286</span>                return (T) resultSet.getArray(columnLabel);<a name="line.286"></a>
<span class="sourceLineNo">287</span>            }<a name="line.287"></a>
<span class="sourceLineNo">288</span>            if (type == Blob.class) {<a name="line.288"></a>
<span class="sourceLineNo">289</span>                return (T) resultSet.getBlob(columnLabel);<a name="line.289"></a>
<span class="sourceLineNo">290</span>            }<a name="line.290"></a>
<span class="sourceLineNo">291</span>            if (type == Clob.class) {<a name="line.291"></a>
<span class="sourceLineNo">292</span>                return (T) resultSet.getClob(columnLabel);<a name="line.292"></a>
<span class="sourceLineNo">293</span>            }<a name="line.293"></a>
<span class="sourceLineNo">294</span>            if (type == Ref.class) {<a name="line.294"></a>
<span class="sourceLineNo">295</span>                return (T) resultSet.getRef(columnLabel);<a name="line.295"></a>
<span class="sourceLineNo">296</span>            }<a name="line.296"></a>
<span class="sourceLineNo">297</span>            if (type == RowId.class) {<a name="line.297"></a>
<span class="sourceLineNo">298</span>                return (T) resultSet.getRowId(columnLabel);<a name="line.298"></a>
<span class="sourceLineNo">299</span>            }<a name="line.299"></a>
<span class="sourceLineNo">300</span>            if (type == SQLXML.class) {<a name="line.300"></a>
<span class="sourceLineNo">301</span>                return (T) resultSet.getSQLXML(columnLabel);<a name="line.301"></a>
<span class="sourceLineNo">302</span>            }<a name="line.302"></a>
<span class="sourceLineNo">303</span>            if (type == URL.class) {<a name="line.303"></a>
<span class="sourceLineNo">304</span>                return (T) resultSet.getURL(columnLabel);<a name="line.304"></a>
<span class="sourceLineNo">305</span>            }<a name="line.305"></a>
<span class="sourceLineNo">306</span>            throw new SQLFeatureNotSupportedException(<a name="line.306"></a>
<span class="sourceLineNo">307</span>                    String.format("resultSet=%s, columnLabel=%s, type=%s", resultSet, columnLabel, type));<a name="line.307"></a>
<span class="sourceLineNo">308</span>        }<a name="line.308"></a>
<span class="sourceLineNo">309</span>    }<a name="line.309"></a>
<span class="sourceLineNo">310</span><a name="line.310"></a>
<span class="sourceLineNo">311</span>    /**<a name="line.311"></a>
<span class="sourceLineNo">312</span>     * Delegates to {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)} without throwing a<a name="line.312"></a>
<span class="sourceLineNo">313</span>     * {@link AbstractMethodError}.<a name="line.313"></a>
<span class="sourceLineNo">314</span>     * &lt;p&gt;<a name="line.314"></a>
<span class="sourceLineNo">315</span>     * If the JDBC driver does not implement {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)},<a name="line.315"></a>
<span class="sourceLineNo">316</span>     * then return null.<a name="line.316"></a>
<span class="sourceLineNo">317</span>     * &lt;/p&gt;<a name="line.317"></a>
<span class="sourceLineNo">318</span>     *<a name="line.318"></a>
<span class="sourceLineNo">319</span>     * @param databaseMetaData<a name="line.319"></a>
<span class="sourceLineNo">320</span>     *            the receiver<a name="line.320"></a>
<span class="sourceLineNo">321</span>     * @param catalog<a name="line.321"></a>
<span class="sourceLineNo">322</span>     *            See {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)}<a name="line.322"></a>
<span class="sourceLineNo">323</span>     * @param schemaPattern<a name="line.323"></a>
<span class="sourceLineNo">324</span>     *            See {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)}<a name="line.324"></a>
<span class="sourceLineNo">325</span>     * @param tableNamePattern<a name="line.325"></a>
<span class="sourceLineNo">326</span>     *            See {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)}<a name="line.326"></a>
<span class="sourceLineNo">327</span>     * @param columnNamePattern<a name="line.327"></a>
<span class="sourceLineNo">328</span>     *            See {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)}<a name="line.328"></a>
<span class="sourceLineNo">329</span>     * @return See {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)}<a name="line.329"></a>
<span class="sourceLineNo">330</span>     * @throws SQLException<a name="line.330"></a>
<span class="sourceLineNo">331</span>     *             See {@link DatabaseMetaData#getPseudoColumns(String, String, String, String)}<a name="line.331"></a>
<span class="sourceLineNo">332</span>     * @see DatabaseMetaData#getPseudoColumns(String, String, String, String)<a name="line.332"></a>
<span class="sourceLineNo">333</span>     */<a name="line.333"></a>
<span class="sourceLineNo">334</span>    public static ResultSet getPseudoColumns(final DatabaseMetaData databaseMetaData, final String catalog,<a name="line.334"></a>
<span class="sourceLineNo">335</span>            final String schemaPattern, final String tableNamePattern, final String columnNamePattern)<a name="line.335"></a>
<span class="sourceLineNo">336</span>            throws SQLException {<a name="line.336"></a>
<span class="sourceLineNo">337</span>        try {<a name="line.337"></a>
<span class="sourceLineNo">338</span>            return databaseMetaData.getPseudoColumns(catalog, schemaPattern, tableNamePattern, columnNamePattern);<a name="line.338"></a>
<span class="sourceLineNo">339</span>        } catch (final AbstractMethodError e) {<a name="line.339"></a>
<span class="sourceLineNo">340</span>            // do nothing<a name="line.340"></a>
<span class="sourceLineNo">341</span>            return null;<a name="line.341"></a>
<span class="sourceLineNo">342</span>        }<a name="line.342"></a>
<span class="sourceLineNo">343</span>    }<a name="line.343"></a>
<span class="sourceLineNo">344</span><a name="line.344"></a>
<span class="sourceLineNo">345</span>    /**<a name="line.345"></a>
<span class="sourceLineNo">346</span>     * Delegates to {@link Connection#getSchema()} without throwing an {@link AbstractMethodError}.<a name="line.346"></a>
<span class="sourceLineNo">347</span>     * &lt;p&gt;<a name="line.347"></a>
<span class="sourceLineNo">348</span>     * If the JDBC driver does not implement {@link Connection#getSchema()}, then return null.<a name="line.348"></a>
<span class="sourceLineNo">349</span>     * &lt;/p&gt;<a name="line.349"></a>
<span class="sourceLineNo">350</span>     *<a name="line.350"></a>
<span class="sourceLineNo">351</span>     * @param connection<a name="line.351"></a>
<span class="sourceLineNo">352</span>     *            the receiver<a name="line.352"></a>
<span class="sourceLineNo">353</span>     * @return null for a JDBC 4 driver or a value per {@link Connection#getSchema()}.<a name="line.353"></a>
<span class="sourceLineNo">354</span>     * @throws SQLException<a name="line.354"></a>
<span class="sourceLineNo">355</span>     *             See {@link Connection#getSchema()}.<a name="line.355"></a>
<span class="sourceLineNo">356</span>     * @see Connection#getSchema()<a name="line.356"></a>
<span class="sourceLineNo">357</span>     */<a name="line.357"></a>
<span class="sourceLineNo">358</span>    public static String getSchema(final Connection connection) throws SQLException {<a name="line.358"></a>
<span class="sourceLineNo">359</span>        try {<a name="line.359"></a>
<span class="sourceLineNo">360</span>            return connection.getSchema();<a name="line.360"></a>
<span class="sourceLineNo">361</span>        } catch (final AbstractMethodError e) {<a name="line.361"></a>
<span class="sourceLineNo">362</span>            // do nothing<a name="line.362"></a>
<span class="sourceLineNo">363</span>            return null;<a name="line.363"></a>
<span class="sourceLineNo">364</span>        }<a name="line.364"></a>
<span class="sourceLineNo">365</span>    }<a name="line.365"></a>
<span class="sourceLineNo">366</span><a name="line.366"></a>
<span class="sourceLineNo">367</span>    /**<a name="line.367"></a>
<span class="sourceLineNo">368</span>     * Delegates to {@link Connection#setNetworkTimeout(Executor, int)} without throwing an {@link AbstractMethodError}.<a name="line.368"></a>
<span class="sourceLineNo">369</span>     * &lt;p&gt;<a name="line.369"></a>
<span class="sourceLineNo">370</span>     * If the JDBC driver does not implement {@link Connection#setNetworkTimeout(Executor, int)}, then do nothing.<a name="line.370"></a>
<span class="sourceLineNo">371</span>     * &lt;/p&gt;<a name="line.371"></a>
<span class="sourceLineNo">372</span>     *<a name="line.372"></a>
<span class="sourceLineNo">373</span>     * @param connection<a name="line.373"></a>
<span class="sourceLineNo">374</span>     *            the receiver<a name="line.374"></a>
<span class="sourceLineNo">375</span>     * @param executor<a name="line.375"></a>
<span class="sourceLineNo">376</span>     *            See {@link Connection#setNetworkTimeout(Executor, int)}<a name="line.376"></a>
<span class="sourceLineNo">377</span>     * @param milliseconds<a name="line.377"></a>
<span class="sourceLineNo">378</span>     *            {@link Connection#setNetworkTimeout(Executor, int)}<a name="line.378"></a>
<span class="sourceLineNo">379</span>     * @throws SQLException<a name="line.379"></a>
<span class="sourceLineNo">380</span>     *             {@link Connection#setNetworkTimeout(Executor, int)}<a name="line.380"></a>
<span class="sourceLineNo">381</span>     * @see Connection#setNetworkTimeout(Executor, int)<a name="line.381"></a>
<span class="sourceLineNo">382</span>     */<a name="line.382"></a>
<span class="sourceLineNo">383</span>    public static void setNetworkTimeout(final Connection connection, final Executor executor, final int milliseconds)<a name="line.383"></a>
<span class="sourceLineNo">384</span>            throws SQLException {<a name="line.384"></a>
<span class="sourceLineNo">385</span>        try {<a name="line.385"></a>
<span class="sourceLineNo">386</span>            connection.setNetworkTimeout(executor, milliseconds);<a name="line.386"></a>
<span class="sourceLineNo">387</span>        } catch (final AbstractMethodError e) {<a name="line.387"></a>
<span class="sourceLineNo">388</span>            // do nothing<a name="line.388"></a>
<span class="sourceLineNo">389</span>        }<a name="line.389"></a>
<span class="sourceLineNo">390</span>    }<a name="line.390"></a>
<span class="sourceLineNo">391</span><a name="line.391"></a>
<span class="sourceLineNo">392</span>    /**<a name="line.392"></a>
<span class="sourceLineNo">393</span>     * Delegates to {@link Connection#setSchema(String)} without throwing an {@link AbstractMethodError}.<a name="line.393"></a>
<span class="sourceLineNo">394</span>     * &lt;p&gt;<a name="line.394"></a>
<span class="sourceLineNo">395</span>     * If the JDBC driver does not implement {@link Connection#setSchema(String)}, then do nothing.<a name="line.395"></a>
<span class="sourceLineNo">396</span>     * &lt;/p&gt;<a name="line.396"></a>
<span class="sourceLineNo">397</span>     *<a name="line.397"></a>
<span class="sourceLineNo">398</span>     * @param connection<a name="line.398"></a>
<span class="sourceLineNo">399</span>     *            the receiver<a name="line.399"></a>
<span class="sourceLineNo">400</span>     * @param schema<a name="line.400"></a>
<span class="sourceLineNo">401</span>     *            See {@link Connection#setSchema(String)}.<a name="line.401"></a>
<span class="sourceLineNo">402</span>     * @throws SQLException<a name="line.402"></a>
<span class="sourceLineNo">403</span>     *             See {@link Connection#setSchema(String)}.<a name="line.403"></a>
<span class="sourceLineNo">404</span>     * @see Connection#setSchema(String)<a name="line.404"></a>
<span class="sourceLineNo">405</span>     */<a name="line.405"></a>
<span class="sourceLineNo">406</span>    public static void setSchema(final Connection connection, final String schema) throws SQLException {<a name="line.406"></a>
<span class="sourceLineNo">407</span>        try {<a name="line.407"></a>
<span class="sourceLineNo">408</span>            connection.setSchema(schema);<a name="line.408"></a>
<span class="sourceLineNo">409</span>        } catch (final AbstractMethodError e) {<a name="line.409"></a>
<span class="sourceLineNo">410</span>            // do nothing<a name="line.410"></a>
<span class="sourceLineNo">411</span>        }<a name="line.411"></a>
<span class="sourceLineNo">412</span>    }<a name="line.412"></a>
<span class="sourceLineNo">413</span><a name="line.413"></a>
<span class="sourceLineNo">414</span>    /**<a name="line.414"></a>
<span class="sourceLineNo">415</span>     * Delegates to {@link Statement#closeOnCompletion()} without throwing an {@link AbstractMethodError}.<a name="line.415"></a>
<span class="sourceLineNo">416</span>     * &lt;p&gt;<a name="line.416"></a>
<span class="sourceLineNo">417</span>     * If the JDBC driver does not implement {@link Statement#closeOnCompletion()}, then just check that the connection<a name="line.417"></a>
<span class="sourceLineNo">418</span>     * is closed to then throw an SQLException.<a name="line.418"></a>
<span class="sourceLineNo">419</span>     * &lt;/p&gt;<a name="line.419"></a>
<span class="sourceLineNo">420</span>     *<a name="line.420"></a>
<span class="sourceLineNo">421</span>     * @param statement<a name="line.421"></a>
<span class="sourceLineNo">422</span>     *            See {@link Statement#closeOnCompletion()}<a name="line.422"></a>
<span class="sourceLineNo">423</span>     * @throws SQLException<a name="line.423"></a>
<span class="sourceLineNo">424</span>     *             See {@link Statement#closeOnCompletion()}<a name="line.424"></a>
<span class="sourceLineNo">425</span>     * @see Statement#closeOnCompletion()<a name="line.425"></a>
<span class="sourceLineNo">426</span>     */<a name="line.426"></a>
<span class="sourceLineNo">427</span>    public static void closeOnCompletion(final Statement statement) throws SQLException {<a name="line.427"></a>
<span class="sourceLineNo">428</span>        try {<a name="line.428"></a>
<span class="sourceLineNo">429</span>            statement.closeOnCompletion();<a name="line.429"></a>
<span class="sourceLineNo">430</span>        } catch (final AbstractMethodError e) {<a name="line.430"></a>
<span class="sourceLineNo">431</span>            if (statement.isClosed()) {<a name="line.431"></a>
<span class="sourceLineNo">432</span>                throw new SQLException("Statement closed");<a name="line.432"></a>
<span class="sourceLineNo">433</span>            }<a name="line.433"></a>
<span class="sourceLineNo">434</span>        }<a name="line.434"></a>
<span class="sourceLineNo">435</span>    }<a name="line.435"></a>
<span class="sourceLineNo">436</span><a name="line.436"></a>
<span class="sourceLineNo">437</span>    /**<a name="line.437"></a>
<span class="sourceLineNo">438</span>     * Delegates to {@link Statement#isCloseOnCompletion()} without throwing an {@link AbstractMethodError}.<a name="line.438"></a>
<span class="sourceLineNo">439</span>     * &lt;p&gt;<a name="line.439"></a>
<span class="sourceLineNo">440</span>     * If the JDBC driver does not implement {@link Statement#isCloseOnCompletion()}, then just check that the<a name="line.440"></a>
<span class="sourceLineNo">441</span>     * connection is closed to then throw an SQLException.<a name="line.441"></a>
<span class="sourceLineNo">442</span>     * &lt;/p&gt;<a name="line.442"></a>
<span class="sourceLineNo">443</span>     *<a name="line.443"></a>
<span class="sourceLineNo">444</span>     * @param statement<a name="line.444"></a>
<span class="sourceLineNo">445</span>     *            See {@link Statement#isCloseOnCompletion()}<a name="line.445"></a>
<span class="sourceLineNo">446</span>     * @return See {@link Statement#isCloseOnCompletion()}<a name="line.446"></a>
<span class="sourceLineNo">447</span>     * @throws SQLException<a name="line.447"></a>
<span class="sourceLineNo">448</span>     *             See {@link Statement#isCloseOnCompletion()}<a name="line.448"></a>
<span class="sourceLineNo">449</span>     * @see Statement#closeOnCompletion()<a name="line.449"></a>
<span class="sourceLineNo">450</span>     */<a name="line.450"></a>
<span class="sourceLineNo">451</span>    public static boolean isCloseOnCompletion(final Statement statement) throws SQLException {<a name="line.451"></a>
<span class="sourceLineNo">452</span>        try {<a name="line.452"></a>
<span class="sourceLineNo">453</span>            return statement.isCloseOnCompletion();<a name="line.453"></a>
<span class="sourceLineNo">454</span>        } catch (final AbstractMethodError e) {<a name="line.454"></a>
<span class="sourceLineNo">455</span>            if (statement.isClosed()) {<a name="line.455"></a>
<span class="sourceLineNo">456</span>                throw new SQLException("Statement closed");<a name="line.456"></a>
<span class="sourceLineNo">457</span>            }<a name="line.457"></a>
<span class="sourceLineNo">458</span>            return false;<a name="line.458"></a>
<span class="sourceLineNo">459</span>        }<a name="line.459"></a>
<span class="sourceLineNo">460</span>    }<a name="line.460"></a>
<span class="sourceLineNo">461</span><a name="line.461"></a>
<span class="sourceLineNo">462</span>    /**<a name="line.462"></a>
<span class="sourceLineNo">463</span>     * Delegates to {@link CommonDataSource#getParentLogger()} without throwing an {@link AbstractMethodError}.<a name="line.463"></a>
<span class="sourceLineNo">464</span>     * &lt;p&gt;<a name="line.464"></a>
<span class="sourceLineNo">465</span>     * If the JDBC driver does not implement {@link CommonDataSource#getParentLogger()}, then return null.<a name="line.465"></a>
<span class="sourceLineNo">466</span>     * &lt;/p&gt;<a name="line.466"></a>
<span class="sourceLineNo">467</span>     *<a name="line.467"></a>
<span class="sourceLineNo">468</span>     * @param commonDataSource<a name="line.468"></a>
<span class="sourceLineNo">469</span>     *            See {@link CommonDataSource#getParentLogger()}<a name="line.469"></a>
<span class="sourceLineNo">470</span>     * @return See {@link CommonDataSource#getParentLogger()}<a name="line.470"></a>
<span class="sourceLineNo">471</span>     * @throws SQLFeatureNotSupportedException<a name="line.471"></a>
<span class="sourceLineNo">472</span>     *             See {@link CommonDataSource#getParentLogger()}<a name="line.472"></a>
<span class="sourceLineNo">473</span>     */<a name="line.473"></a>
<span class="sourceLineNo">474</span>    public static Logger getParentLogger(final CommonDataSource commonDataSource) throws SQLFeatureNotSupportedException {<a name="line.474"></a>
<span class="sourceLineNo">475</span>        try {<a name="line.475"></a>
<span class="sourceLineNo">476</span>            return commonDataSource.getParentLogger();<a name="line.476"></a>
<span class="sourceLineNo">477</span>        } catch (final AbstractMethodError e) {<a name="line.477"></a>
<span class="sourceLineNo">478</span>            throw new SQLFeatureNotSupportedException("javax.sql.CommonDataSource#getParentLogger()");<a name="line.478"></a>
<span class="sourceLineNo">479</span>        }<a name="line.479"></a>
<span class="sourceLineNo">480</span>    }<a name="line.480"></a>
<span class="sourceLineNo">481</span><a name="line.481"></a>
<span class="sourceLineNo">482</span>}<a name="line.482"></a>




























































</pre>
</div>
</body>
</html>
